=== test/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_LIST_DIR}/../src)
include(owncloud_add_test.cmake)

owncloud_add_test(DanimoStinkt)
