=== debian/changelog ===
owncloud-client (1.3.0+dfsg-1.1~ubuntu1) saucy; urgency=low

  * Upload from Debian DELAYED queue to fix FTBFS.

 -- Iain Lane <laney@ubuntu.com>  Sat, 07 Sep 2013 18:13:43 +0000

owncloud-client (1.3.0+dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't run dh_sphinxdoc in an arch-dep build. (Closes: #719176)

 -- Iain Lane <laney@debian.org>  Sat, 07 Sep 2013 17:41:01 +0000

owncloud-client (1.3.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Updated version dependency for ocsync
  * Updated debian/libowncloudsync0.symbols
  * Updated lintian-overrides: hardening-no-fortify-functions
  * Make sphinx documentation compile in parallel (Closes: #719178)
  * Fixed: desktop-entry-lacks-keywords-entry lintian warning

 -- Sandro Knauß <bugs@sandroknauss.de>  Thu, 15 Aug 2013 22:08:41 +0200

owncloud-client (1.2.5+dfsg-1) unstable; urgency=low

  * Initial release for debian. (Closes: #692872)

 -- Sandro Knauß <bugs@sandroknauss.de>  Tue, 14 May 2013 03:06:42 +0200
