=== debian/control ===
Source: owncloud-client
Section: net
Priority: optional
Maintainer: ownCloud for Debian maintainers <pkg-owncloud-maintainers@lists.alioth.debian.org>
Uploaders: Sandro Knauß <bugs@sandroknauss.de>
Build-Depends: debhelper (>= 9), cmake, libqt4-dev, hardening-wrapper, pkg-kde-tools,
 python-sphinx (>= 1.0.7+dfsg) | python3-sphinx, texlive-latex-recommended, texlive-latex-extra, texlive-fonts-recommended,
 qt4-dev-tools,  kdelibs5-dev, libocsync-dev (>= 0.80.0), qtkeychain-dev, asciidoc, xsltproc
Vcs-Git: git://anonscm.debian.org/pkg-owncloud/owncloud-client.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-owncloud/owncloud-client.git
Standards-Version: 3.9.4
Homepage: http://owncloud.org/sync-clients/

Package: owncloud-client
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 libowncloudsync0 (= ${binary:Version}), mirall-l10n, libocsync-plugin-owncloud
Description: folder synchronization with an ownCloud server - GUI
 The ownCloudSync system lets you always have your latest files wherever
 you are. Just specify one or more folders on the local machine to and a server
 to synchronize to. You can configure more computers to synchronize to the same
 server and any change to the files on one computer will silently and reliably
 flow across to every other.
 .
 owncloud-client provides the graphical client specialising in
 synchronizing with cloud storage provided by ownCloud.

Package: mirall-doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Section: doc
Description: ownCloudSync folder synchronization - documentation
 The ownCloudSync system lets you always have your latest files wherever
 you are. Just specify one or more folders on the local machine to and a server
 to synchronize to. You can configure more computers to synchronize to the same
 server and any change to the files on one computer will silently and reliably
 flow across to every other.
 .
 This package provides the documentation.

Package: libowncloudsync0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libocsync0 (>= 0.80.0)
Section: libs
Description: ownCloudSync folder synchronization - libraries
 The ownCloudSync system lets you always have your latest files wherever
 you are. Just specify one or more folders on the local machine to and a server
 to synchronize to. You can configure more computers to synchronize to the same
 server and any change to the files on one computer will silently and reliably
 flow across to every other.
 .
 This library is based on CSync, but adds functions that are missing in
 CSync and more specific to graphical clients.

Package: mirall-l10n
Architecture: all
Depends: ${misc:Depends}
Section: localization
Description: ownCloudSync folder synchronization - localization
 The ownCloudSync system lets you always have your latest files wherever
 you are. Just specify one or more folders on the local machine to and a server
 to synchronize to. You can configure more computers to synchronize to the same
 server and any change to the files on one computer will silently and reliably
 flow across to every other.
 .
 This package provides the localization.
